/****************************************************************************/
/* RWS - beta version 0.60                                                  */
/****************************************************************************/

// RWSCLS.C
// Remote Workplace Server - Server WPS class "RWSxx" implementation

/****************************************************************************/

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Remote Workplace Server - Server component.
 *
 * The Initial Developer of the Original Code is Richard L. Walsh.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */

/****************************************************************************/
/*

"RWSxx" is a subclass of WPTransient whose only purpose is to anchor
the RWS server thread in the WPS process.  It is not loaded automatically
by the WPS;  rather, the client (RWSCLIxx.DLL) forces this to happen by
creating an instance of the class.  Once loaded, RWS ensures it won't
be unloaded, then starts the server thread.

*/
/****************************************************************************/

/*
 *  This file was generated by the SOM Compiler and Emitter Framework.
 *  Generated using: 
 *      SOM Emitter emitctm: 2.41
 */

#ifndef SOM_Module_rwscls_Source
#define SOM_Module_rwscls_Source
#endif
#define RWS06_Class_Source
#define M_RWS06_Class_Source

#include "RWSCLS.IH"

/****************************************************************************/

// rwscls.h contains this macro:
//    #define somresolve_(obj,mToken) ((somMethodProc*)((void)obj, mToken))
// redefining it to eliminate the reference to "obj" keeps VAC++3.65
// from generating an informational message for every method call

#undef somresolve_
#define somresolve_(obj,mToken) ((somMethodProc*)(mToken))

// these nonexistent functions are referenced by "#pragma linkage"
// statements in somltypes.h;  declaring them here keeps VAC happy
void somGenericApply(void);
void somResolveDLocator(void);
void somResolveMLocator(void);

/****************************************************************************/

// from RWSINIT.C  (avoid dragging RWSSRV.H's baggage into this module)

void    _System ServerThreadProc( ULONG ul);

/****************************************************************************/

SOM_Scope void SOMLINK somDefaultInit( RWS06* somSelf, somInitCtrl* ctrl)

{
    somInitCtrl globalCtrl;
    somBooleanVector myMask;

    RWS06_BeginInitializer_somDefaultInit;
    RWS06_Init_WPTransient_somDefaultInit(somSelf, ctrl);
}

/****************************************************************************/

SOM_Scope void SOMLINK somDestruct( RWS06* somSelf, octet doFree, 
                                    somDestructCtrl* ctrl)

{
    somDestructCtrl globalCtrl;
    somBooleanVector myMask;

    RWS06_BeginDestructor;
    RWS06_EndDestructor;
}

/****************************************************************************/

// this is the only method that does anything useful

SOM_Scope void  SOMLINK wpclsInitData( M_RWS06* somSelf)

{
    TID         tid = 0;

    M_RWS06_parent_M_WPTransient_wpclsInitData(somSelf);

    // prevent SOM from unloading this class (and thus, the dll it's in)
    _wpclsIncUsage( somSelf);

    // start the thread that does all of the work
    if (DosCreateThread( &tid, &ServerThreadProc, 0, CREATE_READY, 0xf000))
        DosBeep( 660, 120);

    return;
}

/****************************************************************************/

SOM_Scope void  SOMLINK wpclsUnInitData( M_RWS06* somSelf)

{
    // this should *never* get called (except at shutdown)
    DosBeep( 1200, 120);
    M_RWS06_parent_M_WPTransient_wpclsUnInitData(somSelf);
}

/****************************************************************************/

SOM_Scope PSZ  SOMLINK wpclsQueryTitle( M_RWS06* somSelf)

{
    return ("RWS06");
}

/****************************************************************************/

